#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define NUM_SAMPLES 100
#define NUM_ITER 10000
#define STARTING_STEPSIZE 5.0
#define MAX_ABS_RANGE 500.0
#define INITIAL_T 1000.0
#define T_ALPHA 4
#define T_REDUCE(x) (INITIAL_T*pow((1.0-(x/INITIAL_T)), T_ALPHA))
#define T_REDUCE_INTERVAL (NUM_ITER/1000)


double f(double x);
double g(double x);
double anneal(void);

int main(void){
	int i;
	double x;

	srand48(time(NULL));

	for(i=0;i<NUM_SAMPLES;i++){
		x=anneal();
		printf("%g\t%g\n", x, f(x));
	}	
}

double anneal(void){
	int i;
	double x, stepsize, temp;

	x = (drand48()*MAX_ABS_RANGE*((rand()%2)?1:-1));

	temp=INITIAL_T;
	for(i=0;i<NUM_ITER;i++){
		stepsize=(temp/INITIAL_T)*((2*drand48())-1);
		//stepsize=((2*drand48())-1);
		if(f(x+stepsize)<=f(x) || rand()>((double)RAND_MAX*temp/INITIAL_T)) 
			x+=stepsize;
		if(i%T_REDUCE_INTERVAL==0) temp=T_REDUCE(i);
	}	
	return x;
}

double f(double x){
	//return x*x+(4.0*sin(x*x));
	return x*x+(4.0*cos(x*x));
}

double g(double x){
	return x*x+(4.0*cos(x*x));
	//return cos(x)/cos(x*x);
}
